# Java 运行时的内存划分

![](https://ws1.sinaimg.cn/large/006tNc79ly1fmk5v19cmvj30g20anq3y.jpg)

## 程序计数器

记录当前线程所执行的字节码行号，用于获取下一条执行的字节码。

当多线程运行时，每个线程切换后需要知道上一次所运行的状态、位置。由此也可以看出程序计数器是每个线程**私有**的。


## 虚拟机栈
虚拟机栈是有一个一个的栈帧组成，栈帧是在每一个方法调用时产生的。

每一个栈帧由`局部变量区`、`操作数栈`等组成。每创建一个栈帧压栈，当一个方法执行完毕之后则出栈。

> 如果出现方法递归调用出现死循环的话就会造成栈帧过多，最终会抛出 `stackoverflow` 异常。

**这块内存区域也是线程私有的。**

## Java 堆
`Java` 堆是整个虚拟机所管理的最大内存区域，所有的对象创建都是在这个区域进行内存分配。

这块区域也是垃圾回收器重点管理的区域，由于大多数垃圾回收器都采用`分代回收算法`，所有堆内存也分为 `新生代`、`老年代`，可以方便垃圾的准确回收。

**这块内存属于线程共享区域。**

## 方法区

方法区主要用于存放已经被虚拟机加载的类信息，如`常量，静态变量`。
这块区域也被称为`老年代`。

### 运行时常量池

运行时常量池是方法区的一部分，其中存放了一些符号引用。当 new 一个对象时，会检查这个区域是否有这个符号的引用。
